/*
 * RGBColor.java
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class RGBColor extends JFrame 
{
	
	static JLabel colorLabel = new JLabel();
	static JSlider redSlider = new JSlider();
	static JSlider greenSlider = new JSlider();
	static JSlider blueSlider = new JSlider();
	static JTextField redTextField = new JTextField();
	static JTextField greenTextField = new JTextField();
	static JTextField blueTextField = new JTextField();
	

  public static void main(String args[]) 
  {
  	// construct frame
    new RGBColor().show();
  }
  
  public RGBColor() 
  {
    // create frame
    setTitle("RGB Color Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls
    Font myFont = new Font("Arial", Font.BOLD, 24);
   
    GridBagConstraints gridConstraints;
    colorLabel.setPreferredSize(new Dimension (300, 60));
    colorLabel.setOpaque(true);
    colorLabel.setBackground(new Color(255, 255, 255));
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.gridwidth = 3;
    getContentPane().add(colorLabel, gridConstraints);

    redSlider.setPreferredSize(new Dimension (100, 30));
    redSlider.setMinimum(0);
    redSlider.setMaximum(255);
    redSlider.setValue(255);
    redSlider.setOrientation(JSlider.HORIZONTAL);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(redSlider, gridConstraints);
		redSlider.addChangeListener(new ChangeListener()
		{
  		public void stateChanged(ChangeEvent e) 
  		{
    		sliderStateChanged(e);
  		}
		});

    greenSlider.setPreferredSize(new Dimension (100, 30));
    greenSlider.setMinimum(0);
    greenSlider.setMaximum(255);
    greenSlider.setValue(255);
    greenSlider.setOrientation(JSlider.HORIZONTAL);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(greenSlider, gridConstraints);
		greenSlider.addChangeListener(new ChangeListener()
		{
  		public void stateChanged(ChangeEvent e) 
  		{
    		sliderStateChanged(e);
  		}
		});

    blueSlider.setPreferredSize(new Dimension (100, 30));
    blueSlider.setMinimum(0);
    blueSlider.setMaximum(255);
    blueSlider.setValue(255);
    blueSlider.setOrientation(JSlider.HORIZONTAL);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    getContentPane().add(blueSlider, gridConstraints);
		blueSlider.addChangeListener(new ChangeListener()
		{
  		public void stateChanged(ChangeEvent e) 
  		{
    		sliderStateChanged(e);
  		}
		});

    redTextField.setText("255");
    redTextField.setColumns(3);
    redTextField.setFont(myFont);
    redTextField.setEditable(false);
    redTextField.setBackground(Color.WHITE);
    redTextField.setForeground(Color.RED);
    redTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(redTextField, gridConstraints);
    greenTextField.setText("255");
    greenTextField.setColumns(3);
    greenTextField.setFont(myFont);
    greenTextField.setEditable(false);
    greenTextField.setBackground(Color.WHITE);
    greenTextField.setForeground(Color.GREEN);
    greenTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(greenTextField, gridConstraints);
    blueTextField.setText("255");
    blueTextField.setColumns(3);
    blueTextField.setFont(myFont);
    blueTextField.setEditable(false);
    blueTextField.setBackground(Color.WHITE);
    blueTextField.setForeground(Color.BLUE);
    blueTextField.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    getContentPane().add(blueTextField, gridConstraints);
 
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
  
  
  private void sliderStateChanged (ChangeEvent e) 
	{
    redTextField.setText(String.valueOf(redSlider.getValue()));
    greenTextField.setText(String.valueOf(greenSlider.getValue()));
    blueTextField.setText(String.valueOf(blueSlider.getValue()));
    colorLabel.setBackground(new Color(redSlider.getValue(), greenSlider.getValue(), blueSlider.getValue()));
	}




  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
  
}
