/*
 * TicTacToe.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

public class TicTacToe extends JFrame 
{

	static JLabel whoLabel = new JLabel();
	static JLabel turnLabel = new JLabel();
	static JLabel grid0Label = new JLabel();
	static JLabel grid1Label = new JLabel();
	static JLabel grid2Label = new JLabel();
	static JLabel grid3Label = new JLabel();
	static JLabel grid4Label = new JLabel();
	static JLabel grid5Label = new JLabel();
	static JLabel grid6Label = new JLabel();
	static JLabel grid7Label = new JLabel();
	static JLabel grid8Label = new JLabel();
	static JLabel[] choiceLabel = new JLabel[9];
	static JLabel h1Label = new JLabel();
	static JLabel h2Label = new JLabel();
	static JLabel v1Label = new JLabel();
	static JLabel v2Label = new JLabel();
	static ImageIcon apple = new ImageIcon("apple.gif");
	static ImageIcon orange = new ImageIcon("orange.gif");
	static JButton resetButton = new JButton();

  static boolean appleTurn; // if true, it's apple's turn
  static boolean canClick; // if true, can click grid
  static int numberClicks; // Number of grid clicks
  static int[] marker = new int[9]; // what marker is in what location (1-Earth,2-Sun)

	public static void main(String args[]) 
  {
    // create frame
    new TicTacToe().show();
    // initialize game
    resetButton.doClick();
  }

  public TicTacToe() 
  {
    // frame constructor
    setTitle("Tic-Tac-Toe Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent evt) 
      {
        exitForm(evt);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
   	// position controls
    GridBagConstraints gridConstraints;
        
		gridConstraints = new GridBagConstraints();
    whoLabel.setPreferredSize(new Dimension(100, 100));
    whoLabel.setIcon(apple);
 		gridConstraints.gridx = 2;
 		gridConstraints.gridy = 0;
 		gridConstraints.insets = new Insets(10, 10, 10, 10);
 		getContentPane().add(whoLabel, gridConstraints);
        
		gridConstraints = new GridBagConstraints();
    turnLabel.setText("Turn");
    turnLabel.setFont(new Font("Arial", Font.ITALIC + Font.BOLD, 24));
 		gridConstraints.gridx = 2;
 		gridConstraints.gridy = 1;
 		getContentPane().add(turnLabel, gridConstraints);
        
    choiceLabel[0] = grid0Label;
    choiceLabel[1] = grid1Label;
    choiceLabel[2] = grid2Label;
    choiceLabel[3] = grid3Label;
    choiceLabel[4] = grid4Label;
    choiceLabel[5] = grid5Label;
    choiceLabel[6] = grid6Label;
    choiceLabel[7] = grid7Label;
    choiceLabel[8] = grid8Label;
    int grid = 0;
		for (int j = 2; j < 7; j += 2)
    {
    	for (int i = 0; i < 5; i += 2)
   		{
    		gridConstraints = new GridBagConstraints();
    		choiceLabel[grid].setPreferredSize(new Dimension(100, 100));
    		gridConstraints.gridx = i;
    		gridConstraints.gridy = j;
    		gridConstraints.insets = new Insets(10, 10, 10, 10);
				getContentPane().add(choiceLabel[grid], gridConstraints);
				choiceLabel[grid].addMouseListener(new MouseAdapter() 
				{
  				public void mouseClicked(MouseEvent e) 
  				{
    				labelMouseClicked(e);
  				}
				});
				grid++;
  		}
  	}
  	
  	h1Label.setPreferredSize(new Dimension(360, 10));
  	h1Label.setOpaque(true);
  	h1Label.setBackground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    gridConstraints.gridwidth = 5;
    getContentPane().add(h1Label, gridConstraints);
  	h2Label.setPreferredSize(new Dimension(360, 10));
  	h2Label.setOpaque(true);
  	h2Label.setBackground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 5;
    gridConstraints.gridwidth = 5;
    getContentPane().add(h2Label, gridConstraints);
  	v1Label.setPreferredSize(new Dimension(10, 360));
  	v1Label.setOpaque(true);
  	v1Label.setBackground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    gridConstraints.gridheight = 5;
    getContentPane().add(v1Label, gridConstraints);
  	v2Label.setPreferredSize(new Dimension(10, 360));
  	v2Label.setOpaque(true);
  	v2Label.setBackground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 3;
    gridConstraints.gridy = 2;
    gridConstraints.gridheight = 5;
    getContentPane().add(v2Label, gridConstraints);

  	resetButton.setText("Reset Game");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 7;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(resetButton, gridConstraints);
    resetButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        resetButtonActionPerformed(e);
      }
    });


    
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
  }

	private void labelMouseClicked(MouseEvent e)
	{
		// Decide which picture was clicked (1-9)
		int index;
		boolean win = false;
		Component clickedComponent = e.getComponent();
		for (index = 0; index < 9; index++)
		{
			if (clickedComponent == choiceLabel[index])
			{
				break;
			}
		}
    // If can't click or marker already there return
    if (!canClick || marker[index] != 0)
    {
    	return;
	 	}
    // Increment click then mark
    numberClicks++;
    if (appleTurn)
    {
      marker[index] = 1;
      choiceLabel[index].setIcon(apple);
    }
    else
    {
      marker[index] = 2;
      choiceLabel[index].setIcon(orange);
    }
    // Check for win
    if (marker[0] == marker[index] && marker[1] == marker[index] && marker[2] == marker[index])
    {
      // Top horizontal win
      win = true;
    }
    else if (marker[3] == marker[index] && marker[4] == marker[index] && marker[5] == marker[index])
    {
      // Middle horizontal win
      win = true;
    }
    else if (marker[6] == marker[index] && marker[7] == marker[index] && marker[8] == marker[index])
    {
      // Bottom horizontal win
      win = true;
    }
    else if (marker[0] == marker[index] && marker[3] == marker[index] && marker[6] == marker[index])
    {
      // Left vertical win
      win = true;
    }
    else if (marker[1] == marker[index] && marker[4] == marker[index] && marker[7] == marker[index])
    {
      // Middle vertical win
      win = true;
    }
    else if (marker[2] == marker[index] && marker[5] == marker[index] && marker[8] == marker[index])
    {
      // Right vertical win
      win = true;
    }
    else if (marker[0] == marker[index] && marker[4] == marker[index] && marker[8] == marker[index])
    {
      // Top, left down diagonal win
      win = true;
    }
    else if (marker[6] == marker[index] && marker[4] == marker[index] && marker[2] == marker[index])
    {
    	// Bottom, left up diagonal win
      win = true;
    }
    if (win)
    {
      // There's a win
      turnLabel.setText("Win!!");
      canClick = false;
    }
    else
    {
      // If we got this far, this was no win
      if (numberClicks < 9)
      {
        appleTurn = !appleTurn;
        if (appleTurn)
        {
          whoLabel.setIcon(apple);
        }
        else
        {
          whoLabel.setIcon(orange);
        }
      }
      else
      {
        // If there's nine clicks and no win, it's a tie
        whoLabel.setIcon(null);
        turnLabel.setText("A Tie ...");
        canClick = false;
      }
		}
	}

	private void resetButtonActionPerformed(ActionEvent e)
	{
		// clear board
		for (int i = 0; i < 9; i++)
		{
			choiceLabel[i].setIcon(null);
			marker[i] = 0;
		}
    // Make it apple's turn
    whoLabel.setIcon(apple);
    turnLabel.setText("Turn");
    appleTurn = true;
    canClick = true;
    numberClicks = 0;

	}

  private void exitForm(WindowEvent evt) 
  {
    System.exit(0);
  }
}
